Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34921)
@@ -1122,9 +9555,9 @@
         Name => 'Face1Position',
         Format => 'int16u[4]',
-        RawConv => '$$self{FacesDetected} < 1 ? undef : $val',
         Notes => q{
             top, left, height and width of detected face.  Coordinates are relative to
             the full-sized unrotated image, with increasing Y downwards
         },
+        RawConv => '$$self{FacesDetected} < 1 ? undef : $val',
     },
     0x20 => {
@@ -1171,9 +9604,9 @@
         Name => 'Face1Position',
         Format => 'int16u[4]',
-        RawConv => '$$self{FacesDetected} < 1 ? undef : $val',
         Notes => q{
             top, left, height and width of detected face.  Coordinates are relative to
             the full-sized unrotated image, with increasing Y downwards
         },
+        RawConv => '$$self{FacesDetected} < 1 ? undef : $val',
     },
     0x25 => {
@@ -1220,19 +9653,19 @@
     FORMAT => 'int32u',
     NOTES => q{
-        Tags found only in panorama images from Sony cameras such as the HX1, HX5
-        and TX7.  The width/height values of these tags are not affected by camera
+        Tags found in panorama images from various Sony DSC, NEX, SLT and DSLR
+        cameras.  The width/height values of these tags are not affected by camera
         rotation -- the width is always the longer dimension.
     },
-    # 0: 257
-    1 => 'PanoramaFullWidth', # (including black/grey borders)
+    # 0: 257 for panorama images, 0 for all other images (ref JR)
+    1 => 'PanoramaFullWidth', # (including black/gray borders)
     2 => 'PanoramaFullHeight',
     3 => {
         Name => 'PanoramaDirection',
         PrintConv => {
-            0 => 'Right to Left',
-            1 => 'Left to Right',
-        },
-    },
-    # crop area to remove black/grey borders from full image
+            0 => 'Left or Up',
+            1 => 'Right or Down',
+        },
+    },
+    # crop area to remove black/gray borders from full image
     4 => 'PanoramaCropLeft',
     5 => 'PanoramaCropTop', #PH guess (NC)
@@ -1266,10 +9699,10 @@
         Name => 'SRF2Key',
         Notes => 'key to decrypt maker notes from the start of SRF2',
-        RawConv => '$self->{SRF2Key} = $val',
+        RawConv => '$$self{SRF2Key} = $val',
     },
     1 => {
         Name => 'DataKey',
         Notes => 'key to decrypt the rest of the file from the end of the maker notes',
-        RawConv => '$self->{SRFDataKey} = $val',
+        RawConv => '$$self{SRFDataKey} = $val',
     },
     # SRF0 contains a single unknown tag with TagID 0x0003
@@ -1287,4 +9720,32 @@
     4 => { Name => 'RawDataOffset' }, #PH
     5 => { Name => 'RawDataLength' }, #PH
+    0x0043 => 'MaxApertureAtMaxFocal', #IB
+    0x0044 => 'MaxApertureAtMinFocal', #IB
+    0x0045 => { #IB
+        Name => 'MinFocalLength',
+        PrintConv => '"$val mm"',
+    },
+    0x0046 => { #IB
+        Name => 'MaxFocalLength',
+        PrintConv => '"$val mm"',
+    },
+    0x00c0 => 'WBRedDaylight', #IB
+    0x00c1 => 'WBGreenDaylight', #IB
+    0x00c2 => 'WBBlueDaylight', #IB
+    0x00c3 => 'WBRedCloudy', #IB
+    0x00c4 => 'WBGreenCloudy', #IB
+    0x00c5 => 'WBBlueCloudy', #IB
+    0x00c6 => 'WBRedFluorescent', #IB
+    0x00c7 => 'WBGreenFluorescent', #IB
+    0x00c8 => 'WBBlueFluorescent', #IB
+    0x00c9 => 'WBRedTungsten', #IB
+    0x00ca => 'WBGreenTungsten', #IB
+    0x00cb => 'WBBlueTungsten', #IB
+    0x00cc => 'WBRedFlash', #IB
+    0x00cd => 'WBGreenFlash', #IB
+    0x00ce => 'WBBlueFlash', #IB
+    0x00d0 => 'WBRedAsShot', #IB
+    0x00d1 => 'WBGreenAsShot', #IB
+    0x00d2 => 'WBBlueAsShot', #IB
 );
 
@@ -1363,5 +9824,26 @@
     SET_GROUP1 => 1, # set group1 name to directory name for all tags in table
     NOTES => 'Tags in the encrypted SR2SubIFD',
-    0x7303 => 'WB_GRBGLevels', #1
+    0x7300 => 'BlackLevel', #IB (R1)
+    0x7302 => 'WB_GRBGLevelsAuto', #IB (R1)
+    0x7303 => 'WB_GRBGLevels', #1 (R1 "as shot", ref IB)
+    0x7310 => 'BlackLevel', #IB (divide by 4)
+    0x7312 => 'WB_RGGBLevelsAuto', #IB
+    0x7313 => 'WB_RGGBLevels', #6
+    0x7480 => 'WB_RGBLevelsDaylight', #IB (R1)
+    0x7481 => 'WB_RGBLevelsCloudy', #IB (R1)
+    0x7482 => 'WB_RGBLevelsTungsten', #IB (R1)
+    0x7483 => 'WB_RGBLevelsFlash', #IB (R1)
+    0x7484 => 'WB_RGBLevels4500K', #IB (R1)
+    0x7486 => 'WB_RGBLevelsFluorescent', #IB (R1)
+    0x74a0 => 'MaxApertureAtMaxFocal', #PH
+    0x74a1 => 'MaxApertureAtMinFocal', #PH
+    0x74a2 => { #IB (R1)
+        Name => 'MaxFocalLength',
+        PrintConv => '"$val mm"',
+    },
+    0x74a3 => { #IB (R1)
+        Name => 'MinFocalLength',
+        PrintConv => '"$val mm"',
+    },
     0x74c0 => { #PH
         Name => 'SR2DataIFD',
@@ -1374,13 +9856,23 @@
         },
     },
-    0x7313 => 'WB_RGGBLevels', #6
-    0x74a0 => 'MaxApertureAtMaxFocal', #PH
-    0x74a1 => 'MaxApertureAtMinFocal', #PH
-    0x7820 => 'WB_RGBLevelsDaylight', #6
-    0x7821 => 'WB_RGBLevelsCloudy', #6
+    0x7800 => 'ColorMatrix', #IB (divide by 1024)
+    0x7820 => 'WB_RGBLevelsDaylight', #6 (or 5300K, ref IB)
+    0x7821 => 'WB_RGBLevelsCloudy', #6 (or 6100K, ref IB)
     0x7822 => 'WB_RGBLevelsTungsten', #6
-    0x7825 => 'WB_RGBLevelsShade', #6
-    0x7826 => 'WB_RGBLevelsFluorescent', #6
-    0x7828 => 'WB_RGBLevelsFlash', #6
+    0x7823 => 'WB_RGBLevelsFlash', #IB
+    0x7824 => 'WB_RGBLevels4500K', #IB
+    0x7825 => 'WB_RGBLevelsShade', #6 (or 7500K, ref IB)
+    0x7826 => 'WB_RGBLevelsFluorescent', #6 (~4000K)
+    0x7827 => 'WB_RGBLevelsFluorescentP1', #IB (~5000K)
+    0x7828 => 'WB_RGBLevelsFluorescentP2', #IB (~6500K) (was Flash, ref 6)
+    0x7829 => 'WB_RGBLevelsFluorescentM1', #IB (~3500K)
+    0x782a => 'WB_RGBLevels8500K', #IB
+    0x782b => 'WB_RGBLevels6000K', #IB
+    0x782c => 'WB_RGBLevels3200K', #IB
+    0x782d => 'WB_RGBLevels2500K', #IB
+    0x787f => 'WhiteLevel', #IB (divide by 4)
+    0x797d => 'VignettingCorrParams', #forum7640
+    0x7980 => 'ChromaticAberrationCorrParams', #forum6509 (Sony A7 ARW)
+    0x7982 => 'DistortionCorrParams', #forum6509 (Sony A7 ARW)
 );
 
@@ -1397,9 +9889,48 @@
 );
 
+# extract information from "SONY PIC\0" maker notes (ref PH)
+%Image::ExifTool::Sony::PIC = (
+    PROCESS_PROC => \&ProcessSonyPIC,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => q{
+        The TextInfo data is extracted as a block to preserve the formatting, and
+        some of the more interesting information is extracted as separate tags.
+    },
+    TextInfo1 => { Binary => 1 },
+    TextInfo2 => { Binary => 1 },
+    # tags extracted from TextInfo blocks (ID's must end with ':')
+    'Temp:' => {
+        Name => 'CameraTemperature',
+        RawConv => '$val =~ /^-?\d+/ ? $val : undef',
+        PrintConv => '"$val C"',
+    },
+    'Temp:Clbt:' => { Name => 'BoardTemperature', PrintConv => '"$val C"' }, #(NC)
+    'Capt:' => { Name => 'SensorTemperature', PrintConv => '"$val C"' }, #(NC)
+    'VR Enable C:' => {
+        Name => 'VibrationReduction',
+        PrintConv => { 0 => 'Off', 1 => 'On' }, #(NC)
+    },
+    'FWVer:' => 'FirmwareVersion',
+    'BC:' => {
+        Name => 'Barcode',
+        Condition => 'not $$self{VALUE}{Barcode}',
+        ValueConv => '$val=~s/IP1.*//; $val',
+    },
+    'barcode:' => 'Barcode',
+    'BarCode:' => {
+        Name => 'Barcode',
+        ValueConv => 'length($val) > 12 ? substr($val,0,12) : $val',
+    },
+    # 'EvA:' - exposure compensation * 10 (ref JR)
+    # IFD: for documentation only -- this IFD is handled manually
+    IFD => {
+        Name => 'PIC_IFD',
+        SubDirectory => { TagTable => 'Image::ExifTool::Sony::Main' },
+    },
+);
+
 # tags found in DSC-F1 PMP header (ref 10)
 %Image::ExifTool::Sony::PMP = (
     PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
-    WRITE_PROC => \&Image::ExifTool::WriteBinaryData,
-    CHECK_PROC => \&Image::ExifTool::CheckBinaryData,
     GROUPS => { 0 => 'MakerNotes', 2 => 'Image' },
     FIRST_ENTRY => 0,
@@ -1416,7 +9947,7 @@
         },
     },
-    12 => { Name => 'JpgFromRawLength',Format => 'int32u' },
-    22 => { Name => 'SonyImageWidth',  Format => 'int16u' },
-    24 => { Name => 'SonyImageHeight', Format => 'int16u' },
+    12 => { Name => 'JpgFromRawLength', Format => 'int32u' },
+    22 => { Name => 'SonyImageWidth',   Format => 'int16u' },
+    24 => { Name => 'SonyImageHeight',  Format => 'int16u' },
     27 => {
         Name => 'Orientation',
@@ -1496,13 +10027,189 @@
 );
 
+# tags found in 'rtmd' timed metadata in ILCE-7S/DSC-RX100M6 MP4 videos (ref PH)
+%Image::ExifTool::Sony::rtmd = (
+    PROCESS_PROC => \&Process_rtmd,
+    GROUPS => { 2 => 'Video' },
+    NOTES => q{
+        These tags are extracted from the 'rtmd' timed metadata of MP4 videos from
+        some models when the L<ExtractEmbedded|../ExifTool.html#ExtractEmbedded> option is used.
+    },
+  # 0x060e - 16 bytes starting with 0x060e2b340253 (fake tag ID - comes before 0x8300 container)
+    0x060e => { Name => 'Sony_rtmd_0x060e', Format => 'int8u',  %hidUnk },
+  # 0x32xx - 16 bytes starting with 0x060e2b340401
+    0x3210 => { Name => 'Sony_rtmd_0x3210', Format => 'int8u',  %hidUnk },
+    0x3219 => { Name => 'Sony_rtmd_0x3219', Format => 'int8u',  %hidUnk },
+    0x321a => { Name => 'Sony_rtmd_0x321a', Format => 'int8u',  %hidUnk },
+    0x8000 => { Name => 'Sony_rtmd_0x8000', Format => 'int16u', %hidUnk },
+    0x8001 => { Name => 'Sony_rtmd_0x8001', Format => 'int16u', %hidUnk },
+  # 0x8100 - 16 bytes starting with 0x060e2b340401
+    0x8100 => { Name => 'Sony_rtmd_0x8100', Format => 'int8u',  %hidUnk },
+    0x8101 => { Name => 'Sony_rtmd_0x8101', Format => 'int8u',  %hidUnk }, # seen: 0,1
+    0x8106 => { Name => 'Sony_rtmd_0x8106', Format => 'int32u', %hidUnk }, # seen: "25 1"
+    0x8109 => { Name => 'Sony_rtmd_0x8109', Format => 'int32u', %hidUnk }, # seen: "1 50"
+    0x810a => { Name => 'Sony_rtmd_0x810a', Format => 'int16u', %hidUnk }, # seen: 0
+    0x810b => { Name => 'Sony_rtmd_0x810b', Format => 'int16u', %hidUnk }, # seen: 100
+    0x810c => { Name => 'Sony_rtmd_0x810c', Format => 'int16u', %hidUnk }, # seen: 100
+    0x810d => { Name => 'Sony_rtmd_0x810d', Format => 'int8u',  %hidUnk }, # seen: 1
+    0x8115 => { Name => 'Sony_rtmd_0x8115', Format => 'int16u', %hidUnk }, # seen: 100
+  # 0x8300 - container for other tags in this format
+    0x8500 => {
+        Name => 'GPSVersionID',
+        Groups => { 2 => 'Location' },
+        Format => 'int8u',
+        PrintConv => '$val =~ tr/ /./; $val',
+    },
+    0x8501 => {
+        Name => 'GPSLatitudeRef',
+        Groups => { 2 => 'Location' },
+        Format => 'string',
+        PrintConv => {
+            N => 'North',
+            S => 'South',
+        },
+    },
+    0x8502 => {
+        Name => 'GPSLatitude',
+        Groups => { 2 => 'Location' },
+        Format => 'rational64u',
+        ValueConv => 'require Image::ExifTool::GPS;Image::ExifTool::GPS::ToDegrees($val)',
+        PrintConv => 'Image::ExifTool::GPS::ToDMS($self, $val, 1)',
+    },
+    0x8503 => {
+        Name => 'GPSLongitudeRef',
+        Groups => { 2 => 'Location' },
+        Format => 'string',
+        PrintConv => {
+            E => 'East',
+            W => 'West',
+        },
+    },
+    0x8504 => {
+        Name => 'GPSLongitude',
+        Groups => { 2 => 'Location' },
+        Format => 'rational64u',
+        ValueConv => 'require Image::ExifTool::GPS;Image::ExifTool::GPS::ToDegrees($val)',
+        PrintConv => 'Image::ExifTool::GPS::ToDMS($self, $val, 1)',
+    },
+    0x8507 => {
+        Name => 'GPSTimeStamp',
+        Groups => { 2 => 'Time' },
+        Format => 'rational64u',
+        ValueConv => 'require Image::ExifTool::GPS;Image::ExifTool::GPS::ConvertTimeStamp($val)',
+        PrintConv => 'Image::ExifTool::GPS::PrintTimeStamp($val)',
+    },
+    0x8509 => {
+        Name => 'GPSStatus',
+        Groups => { 2 => 'Location' },
+        Format => 'string',
+        PrintConv => {
+            A => 'Measurement Active',
+            V => 'Measurement Void',
+        },
+    },
+    0x850a => {
+        Name => 'GPSMeasureMode',
+        Groups => { 2 => 'Location' },
+        Format => 'string',
+        PrintConv => {
+            2 => '2-Dimensional Measurement',
+            3 => '3-Dimensional Measurement',
+        },
+    },
+    0x8512 => {
+        Name => 'GPSMapDatum',
+        Groups => { 2 => 'Location' },
+        Format => 'string',
+    },
+    0x851d => {
+        Name => 'GPSDateStamp',
+        Groups => { 2 => 'Time' },
+        Format => 'string',
+        ValueConv => 'Image::ExifTool::Exif::ExifDate($val)',
+    },
+    0xe000 => { Name => 'Sony_rtmd_0xe000', Format => 'int8u',  %hidUnk }, # (16 bytes)
+    0xe300 => { Name => 'Sony_rtmd_0xe300', Format => 'int8u',  %hidUnk }, # seen: 0,1
+    0xe301 => { Name => 'Sony_rtmd_0xe301', Format => 'int32u', %hidUnk }, # seen: 100
+    0xe302 => { Name => 'Sony_rtmd_0xe302', Format => 'int8u',  %hidUnk }, # seen: 1
+    0xe303 => { Name => 'Sony_rtmd_0xe303', Format => 'int8u',  %hidUnk }, # seen: 255
+    0xe304 => {
+        Name => 'DateTime',
+        Groups => { 2 => 'Time' },
+        Format => 'undef',
+        ValueConv => 'my @a=unpack("x1H4H2H2H2H2H2",$val); "$a[0]:$a[1]:$a[2] $a[3]:$a[4]:$a[5]"',
+        PrintConv => '$self->ConvertDateTime($val)',
+    },
+    # f010 - 2048 bytes
+    # f020 - 543 bytes
+);
+
+# Composite Sony tags
+%Image::ExifTool::Sony::Composite = (
+    GROUPS => { 2 => 'Camera' },
+    FocusDistance => {
+        Require => {
+            0 => 'Sony:FocusPosition',
+            1 => 'FocalLength',
+        },
+        Notes => 'distance in metres = FocusPosition * FocalLength / 1000',
+        ValueConv => '$val >= 128 ? "inf" : $val * $val[1] / 1000',
+        PrintConv => '$val eq "inf" ? $val : "$val m"',
+    },
+    FocusDistance2 => {
+        # For DSLR-A550 and newer, NEX/ILCE/SLT/ILCA (only A65V/A77V are missing ...):
+        #     seen FocusPosition2 with values from 80 - 255 (and 21 for Touit 12mm...)
+        # Formula from minolta.pm (WBInfoA100 - 0x49bb) gives mostly correct/acceptable distance indications.
+            # (https://exiftool.org/forum/index.php/topic,3688.0.html)
+            # if this value is the 35mm equivalent magnification, then the formula could
+            # be (1.5 * 2**($val/16-5)+1) * FocalLength, but this tends to underestimate
+            # distance by about 18% (ref 20) (255=inf)
+            # modified 16-10-2014 based on A99V measurements: use FocalLengthIn35mmFormat and leave out the "1.5*" factor.
+        Require => {
+            0 => 'Sony:FocusPosition2',
+            1 => 'FocalLengthIn35mmFormat',
+        },
+        ValueConv => q{
+            return undef unless $val;
+            return 'inf' if $val >= 255;
+            return (2**($val/16-5) + 1) * $val[1] / 1000;
+        },
+        PrintConv => '$val eq "inf" ? $val : sprintf("%.2f m",$val)',
+    },
+    GPSDateTime => {
+        Description => 'GPS Date/Time',
+        Groups => { 2 => 'Time' },
+        SubDoc => 1,    # generate for all sub-documents
+        Require => {
+            0 => 'Sony:GPSDateStamp',
+            1 => 'Sony:GPSTimeStamp',
+        },
+        ValueConv => '"$val[0] $val[1]Z"',
+        PrintConv => '$self->ConvertDateTime($val)',
+    },
+);
+
+# add our composite tags
+Image::ExifTool::AddCompositeTags('Image::ExifTool::Sony');
+
+sub SortLensTypes
+{
+    return $a <=> $b unless $a =~ /\./ and $b =~ /\./;
+    my @a = split /\./, $a;
+    my @b = split /\./, $b;
+    # must compare the decimal part separately to sort in proper order
+    return $a[0] <=> $b[0] || $a[1] <=> $b[1];
+}
+
 # fill in Sony LensType lookup based on Minolta values
 {
     my $minoltaTypes = \%Image::ExifTool::Minolta::minoltaLensTypes;
     %sonyLensTypes = %$minoltaTypes;
-    my $notes = $$minoltaTypes{Notes};
-    delete $$minoltaTypes{Notes};
+    my $other = $$minoltaTypes{OTHER};
+    delete $$minoltaTypes{Notes};   # (temporarily)
+    delete $$minoltaTypes{OTHER};   # (temporarily)
     my $id;
-    foreach $id (sort { $a <=> $b } keys %$minoltaTypes) {
-        # higher numbered lenses are missing last digit of ID for some Sony models
+    # 5-digit lens ID's are missing the last digit (usually "1") in the metadata for
+    # some Sony models, so generate corresponding 4-digit entries for these cameras
+    foreach $id (sort SortLensTypes keys %$minoltaTypes) {
         next if $id < 10000;
         my $sid = int($id/10);
@@ -1524,5 +10231,303 @@
         $sonyLensTypes{$sid} = $lens;
     }
-    $$minoltaTypes{Notes} = $sonyLensTypes{Notes} = $notes;
+    $$minoltaTypes{Notes} = $sonyLensTypes{Notes}; # (restore original Notes)
+    $$minoltaTypes{OTHER} = $other;
+}
+
+#------------------------------------------------------------------------------
+# Process "SONY PIC\0" maker notes (DSC-H200/J10/W370/W510, MHS-TS20, ref PH)
+# Inputs: 0) ExifTool object ref, 1) dirInfo ref, 2) tag table ref
+# Returns: 1
+sub ProcessSonyPIC($$$)
+{
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    my $dataPt = $$dirInfo{DataPt};
+    my $start = $$dirInfo{DirStart} || 0;
+    my $len = $$dirInfo{DirLen} || (length($$dataPt) - $start);
+    my $data = substr($$dataPt, $start, $len);
+
+    # H200 panorama images have an IFD at offset 12 (non-panoramas have 0's here)
+    # - assume other images could too, but do a bit of validation to check
+    # - MHS-TS20 images have some other data here
+    if ($len >= 26) {
+        my $count = Get16u($dataPt, $start + 12);
+        if ($count > 256) {
+            ToggleByteOrder();
+            $count = Get16u($dataPt, $start + 12);
+        }
+        if ($count and $count < 256) {
+            my $format = Get16u($dataPt, $start + 16);
+            if ($format >= 1 and $format <= 10) {
+                $$dirInfo{DirStart} = $start + 12;
+                $$dirInfo{DirLen} = $len - 12;
+                my $sonyTable = GetTagTable('Image::ExifTool::Sony::Main');
+                Image::ExifTool::Exif::ProcessExif($et, $dirInfo, $sonyTable);
+            }
+        }
+    }
+    # Do a brute force search for text data:
+    # For the DSC-J10/W370/W510 the first text block is at offset 0x1ec and
+    # starts with "BarCode:".  For the H200 it is at 0x1f0 and starts with "BC:".
+    # For the TS20 it is at 0x5b and starts with "V400 AELOG\nbarcode:".
+    # The second text block starts with "AFLOG" (Auto-Focus log) and is at
+    # 0x600 for all models, except for the TS20 it is at 0x45b.
+    my $i = 0;
+    while ($data =~ /(\w[\x09\x0a\x0d\x20-\x7e]+)/sg) {
+        next unless length $1 > 32;
+        my ($tag, $val) = ('TextInfo' . (++$i), $1);
+        $$tagTablePtr{$tag} or AddTagToTable($tagTablePtr, $tag, { Name => $tag, Binary => 1 });
+        $et->HandleTag($tagTablePtr, $tag, $val);
+        # extract interesting tags separately (might want to speed this up)
+        foreach $tag (sort { lc $a cmp lc $b } keys %$tagTablePtr) {
+            next unless $tag =~ /:$/ and $val =~ /\b$tag\s*([^\s;,:]+)/;
+            $et->HandleTag($tagTablePtr, $tag, $1);
+        }
+    }
+    return 1;
+}
+
+#------------------------------------------------------------------------------
+# MeterInfo value conversions
+# Inputs: 0) value
+# Returns: converted value
+sub ConvMeter1($)
+{
+    my $val = shift;
+    return \$val unless length($val) == 90;
+    my @a = unpack("SLLSLLSLLSLLSLLSLLSLLSLLSLL",$val);
+    return join ' ', @a;
+}
+sub ConvMeter2($)
+{
+    my $val = shift;
+    return \$val unless length($val) == 110;
+    my @a = unpack("SLLSLLSLLSLLSLLSLLSLLSLLSLLSLLSLL",$val);
+    return join ' ', @a;
+}
+
+#------------------------------------------------------------------------------
+# LensSpec value conversions
+# Inputs: 0) value
+# Returns: converted value
+# Notes: unpacks in format compatible with LensInfo, with extra flags bytes at start and end
+sub ConvLensSpec($)
+{
+    my $val = shift;
+    return \$val unless length($val) == 8;
+    my @a = unpack("H2H4H4H2H2H2",$val);
+    $a[1] += 0;  $a[2] += 0;    # remove leading zeros from focal lengths
+    s/([a-f])/hex($1)/e foreach @a[3,4]; # convert hex digits (ie. "b0" = f11)
+    $a[3] /= 10; $a[4] /= 10;   # divide f-numbers by 10
+    return join ' ', @a;
+}
+sub ConvInvLensSpec($)
+{
+    my $val = shift;
+    my @a=split(" ", $val);
+    return $val unless @a == 6;
+    $a[3] *= 10; $a[4] *= 10;   # f-numbers are multiplied by 10
+    s/^(\d{2})0$/sprintf('%x0',$1)/e foreach @a[3,4];
+    $_ = hex foreach @a;        # convert from hex
+    return pack 'CnnCCC', @a;
+}
+
+#------------------------------------------------------------------------------
+# Print Sony LensSpec value
+# Inputs: 0) LensSpec numerical value
+# Returns: converted LensSpec string (eg. "DT 18-55mm F3.5-5.6 SAM")
+# Refs: http://equational.org/importphotos/alphalensinfo.html
+#       http://www.dyxum.com/dforum/the-lens-information-different-from-lensid_topic37682.html
+my @lensFeatures = (
+    # lens features in the order they are added to the LensSpec string
+    # (high byte of Mask/Bits represents byte 0 of LensSpec, low byte is byte 7)
+    #  Mask   {  Bits     Name    Bits     Name  } Prefix flag
+    # ------    ------    -----  ------    -----   -----------
+    [ 0x4000, { 0x4000 => 'PZ'                   }, 1 ],
+    [ 0x0300, { 0x0100 => 'DT',  0x0200 => 'FE', 0x0300 => 'E'   }, 1 ], # (will come before preceding prefix), FE added (ref JR)
+    [ 0x00e0, { 0x0020 => 'STF', 0x0040 => 'Reflex', 0x0060 => 'Macro', 0x0080 => 'Fisheye' } ],
+    [ 0x000c, { 0x0004 => 'ZA',  0x0008 => 'G'   } ],
+    [ 0x0003, { 0x0001 => 'SSM', 0x0002 => 'SAM' } ],
+    [ 0x8000, { 0x8000 => 'OSS' } ],
+    [ 0x2000, { 0x2000 => 'LE' } ], #JR
+    [ 0x0800, { 0x0800 => 'II' } ], #JR
+);
+sub PrintLensSpec($)
+{
+    my $val = shift;
+    my ($rtnVal, $feature, $f1, $sf, $lf, $sa, $la, $f2);
+    # 0=flags1, 1=short focal, 2=long focal, 3=max aperture at short focal,
+    # 4=max aperture at long focal, 5=flags2
+    my @a = split ' ', $val;
+    if (@a == 2) {  # LensSpecFeatures patch
+        ($f1, $f2) = @a;
+        $rtnVal = '';
+    } elsif (@a >= 6) {
+        ($f1, $sf, $lf, $sa, $la, $f2) = @a;
+        # crude validation of focal length and aperture values
+        if ($sf != 0 and $sa != 0 and ($lf == 0 or $lf >= $sf) and ($la == 0 or $la >= $sa)) {
+            # use focal and aperture range if this is a zoom lens
+            $sf .= '-' . $lf if $lf != $sf and $lf != 0;
+            $sa .= '-' . $la if $sa != $la and $la != 0;
+            $rtnVal = "${sf}mm F$sa";     # heart of LensSpec is a LensInfo string
+        }
+    }
+    if (defined $rtnVal) {
+        # loop through available lens features
+        my $flags = hex($f1 . $f2);
+        foreach $feature (@lensFeatures) {
+            my $bits = $$feature[0] & $flags;
+            next unless $bits or $$feature[1]{$bits};
+            # add feature name as a prefix or suffix to the LensSpec
+            my $str = $$feature[1]{$bits} || sprintf('Unknown(%.4x)',$bits);
+            $rtnVal = $rtnVal ? ($$feature[2] ? "$str $rtnVal" : "$rtnVal $str") : $str;
+        }
+    } else {
+        $rtnVal = "Unknown ($val)";
+    }
+    return $rtnVal;
+}
+# inverse conversion
+sub PrintInvLensSpec($;$$)
+{
+    my ($val, $self, $features) = @_;
+    return $1 if $val =~ /Unknown \((.*)\)/i;
+    my ($sf, $lf, $sa, $la) = Image::ExifTool::Exif::GetLensInfo($val);
+    my $str;
+    if ($features) {
+        $str = '';
+    } elsif ($sf) {
+        # fixed focal length and aperture have zero for 2nd number
+        $lf = 0 if $lf == $sf;
+        $la = 0 if $la == $sa;
+        $str = " $sf $lf $sa $la";
+    } else {
+        return undef;
+    }
+    my $flags = 0;
+    my ($feature, $bits);
+    foreach $feature (@lensFeatures) {
+        foreach $bits (keys %{$$feature[1]}) {
+            # set corresponding flag bits for each feature name found
+            my $name = $$feature[1]{$bits};
+            $val =~ /\b$name\b/i and $flags |= $bits;
+        }
+    }
+    return sprintf "%.2x$str %.2x", $flags>>8, $flags&0xff;
+}
+
+#------------------------------------------------------------------------------
+# Read/Write MoreInfo information (tag 0x0020, count 20480)
+# Inputs: 0) ExifTool object ref, 1) dirInfo ref, 2) tag table ref
+# Returns: 1 on success when reading, or new directory when writing (IsWriting set)
+sub ProcessMoreInfo($$$)
+{
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    $et or return 1;    # allow dummy access to write routine
+    my $dataPt = $$dirInfo{DataPt};
+    my $start = $$dirInfo{DirStart} || 0;
+    my $dirLen = $$dirInfo{DirLen} || length($$dataPt);
+    my $isWriting = $$dirInfo{IsWriting};
+    my $rtnVal = $isWriting ? undef : 0;
+    return $rtnVal if $dirLen < 4;
+
+    my $num = Get16u($dataPt, $start);      # number of entries
+    my $len = Get16u($dataPt, $start + 2);  # total data length
+
+    if ($dirLen < 4 + $num * 4) {
+        $et->Warn('Truncated MoreInfo data', 1);
+        return $rtnVal;
+    }
+    if ($num > 50) {
+        $et->Warn('Possibly corrupted MoreInfo data', 1);
+        return $rtnVal;
+    }
+
+    $et->VerboseDir('MoreInfo', $num, $len) unless $isWriting;
+
+    if ($len > $dirLen) {
+        $et->Warn('MoreInfo data length too large', 1);
+        $len = $dirLen;
+    }
+    # loop through the MoreInfo index section to get the block offsets and tag ID's
+    # (in case they are out of order, even though this may never happen)
+    my ($i, @offset, @tagID, %blockSize);
+    for ($i=0; $i<$num; ++$i) {
+        my $entry = $start + 4 + $i * 4;
+        push @tagID, Get16u($dataPt, $entry);
+        push @offset, Get16u($dataPt, $entry + 2);
+        if ($offset[-1] > $len and $offset[-1] <= $dirLen) {
+            $et->Warn('MoreInfo data length too small', 1);
+            $len = $dirLen;
+        }
+    }
+    # generate a lookup table of block sizes
+    my @sorted = sort { $a <=> $b } @offset;
+    push @sorted, 0xffff;   # (simplifies logic in loop below)
+    for ($i=0; $i<$num; ++$i) {
+        my $offset = $sorted[$i];
+        my $size = $sorted[$i+1] - $offset;
+        # note that block size will be negative for blocks with starting
+        # offsets greater than $dirLen, but we will ignore these below
+        $size = $len - $offset if $size > $len - $offset;
+        # (if blockSize is already defined for this offset, then there
+        #  are 2 blocks with the same starting offset and the existing
+        #  size must be zero.  Since we can't know which block is
+        #  actually non-zero size, the reasonable thing to do is
+        #  assume that both have a size of zero)
+        $blockSize{$offset} = $size unless defined $blockSize{$offset};
+    }
+    # initialize successful return value
+    $rtnVal = $isWriting ? substr($$dataPt, $start, $dirLen) : 1;
+    # now process each block
+    my $unknown = $$et{OPTIONS}{Unknown};
+    for ($i=0; $i<$num; ++$i) {
+        next if $offset[$i] > $dirLen;  # ignore bad offsets
+        my $tag = $tagID[$i];
+        if ($isWriting) {
+            # write new tags
+            my $tagInfo = $$tagTablePtr{$tag};
+            next unless ref $tagInfo eq 'HASH' and $$tagInfo{SubDirectory};
+            my $offset = $offset[$i];
+            my $size = $blockSize{$offset};
+            next unless $size;  # ignore zero-length blocks
+            my %dirInfo = (
+                DirName  => $$tagInfo{Name},
+                Parent   => $$dirInfo{DirName},
+                DataPt   => \$rtnVal,
+                DirStart => $offset,
+                DirLen   => $size,
+            );
+            my $subTable = GetTagTable($$tagInfo{SubDirectory}{TagTable});
+            my $val = $et->WriteDirectory(\%dirInfo, $subTable);
+            # update this block in the returned MoreInfo data
+            substr($rtnVal, $offset, $size) = $val if defined $val;
+            next;
+        }
+        # generate binary tables for unknown tags if -U option used
+        if (not defined $$tagTablePtr{$tag} and $unknown > 1) {
+            my $name = sprintf('MoreInfo%.4x', $tag);
+            my $table = "Image::ExifTool::Sony::$name";
+            no strict 'refs';
+            %$table = (
+                PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+                FIRST_ENTRY => 0,
+                GROUPS => { 0 => 'MakerNotes', 2 => 'Image' },
+            );
+            use strict 'refs';
+            my %tagInfo = (
+                Name => $name,
+                SubDirectory => { TagTable => $table },
+            );
+            AddTagToTable($tagTablePtr, $tag, \%tagInfo);
+        }
+        $et->HandleTag($tagTablePtr, $tag, undef,
+            Index   => $i,
+            DataPt  => $dataPt,
+            DataPos => $$dirInfo{DataPos},
+            Start   => $start + $offset[$i],
+            Size    => $blockSize{$offset[$i]},
+        );
+    }
+    return $rtnVal;
 }
 
@@ -1533,5 +10538,5 @@
 sub ProcessPMP($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
     my $raf = $$dirInfo{RAF};
     my $buff;
